unit PSXTex;

interface

Uses Windows, SysUtils, Classes, Graphics, Dialogs, Cappo, FiceStream;

Type
  PWord = ^Word;
  PByte = ^Byte;
  PLong = ^Longint;

function ReadTex(Tex:TStream;DataOffset:Integer): TBitmap;
function BmpToTex(Src:TBitmap): TMemoryStream;

Const
  DATA_FF7 = $EC;
  DATA_STD = $F0;

implementation

function ReadTex(Tex:TStream;DataOffset:Integer): TBitmap;
var
I,J,X,Y,C:  Integer;
WTmp:       Word;
//WTmp:       Integer;
S1:         PWord;
Line1:      PWord;
Scan:       PByte;
Pal:        TMaxLogPalette;
FalsePal:   PLogPalette;
begin
Result := TBitmap.Create;
Tex.Position := $3C;
Tex.ReadBuffer(X,4);
Tex.ReadBuffer(Y,4);

Tex.Position := $58;
Tex.ReadBuffer(C,4);

Tex.Position := DataOffset;

Case C of
0:  begin //hicolor
//      Result.PixelFormat := pf32Bit;
      Result.PixelFormat := pf15Bit;
      Result.Width := X; Result.Height := Y;
      GetMem(Scan,X*Y*2);
      Tex.ReadBuffer(Scan^,X*Y*2);
      S1 := PWord(Scan);
      For I := 1 to Y do begin
        Line1 := Result.ScanLine[I-1];
        For J := 1 to X do begin
{          WTmp := Trunc(((S1^ or $7C00) shr 10)*255/31);
          WTmp := WTmp or (Trunc((S1^ or $1F)*255/31) shl 16);
          WTmp := WTmp or (Trunc(((S1^ or $3E0) shr 5)*255/31) shl 8);
          WTmp := WTmp or $00000000; }
{          WTmp := 0;
          WTmp := WTmp or ((S1^ or $1F) shl 10);
          WTmp := WTmp or ((S1^ or $3E0));
          WTmp := WTmp or (S1^ or $7C00) shr 10;}
          WTmp := S1^;
          Line1^ := WTmp;
//          Result.Canvas.Pixels[J-1,I-1] := WTmp;
          Inc(Line1); Inc(S1);
        end;
      end;
      FreeMem(Scan);
    end;
Else begin //paletted
    Result.PixelFormat := pf8Bit;
    Result.Width := X; Result.Height := Y;

    Pal.palVersion := $300;
    Pal.palNumEntries := C;
    Tex.ReadBuffer(Pal.palPalEntry,4*C);

    For I := 0 to 255 do begin
      Pal.palPalEntry[I].peFlags := 0;
      WTmp := Pal.palPalEntry[I].peRed;
      Pal.palPalEntry[I].peRed := Pal.palPalEntry[I].peBlue;
      Pal.palPalEntry[I].peBlue := WTmp;
{      Pal.palPalEntry[I].peBlue := 255-Pal.palPalEntry[I].peBlue;
      Pal.palPalEntry[I].peRed := 255-Pal.palPalEntry[I].peRed;
      Pal.palPalEntry[I].peGreen := 255-Pal.palPalEntry[I].peGreen;
      If I=0 then begin
        Pal.palPalEntry[I].peRed := 255;
        Pal.palPalEntry[I].peBlue := 255;
        Pal.palPalEntry[I].peGreen := 255;
      end;}
    end;

    FalsePal := @Pal;
    Result.Palette := CreatePalette(FalsePal^);
//    Tex.Position := Tex.Position-1;
    For I := 1 to Y do begin
      Scan := Result.ScanLine[I-1];
      X := Min(X,Tex.Size-Tex.Position);
      Tex.ReadBuffer(Scan^,X);
    end;

    SelectPalette(Result.Canvas.Handle,Result.Palette,True);
    RealizePalette(Result.Canvas.Handle);

end;
end;

end;

function BmpToTex(Src:TBitmap): TMemoryStream;
var
PB1,PB2:    ^Byte;
B:          Byte;
I:          Integer;
PPal:       PPaletteEntry;
Header:     TStream;
NewBMP:     TBitmap;
begin
If Src.PixelFormat <> pf8Bit then begin
  NewBMP := TBitmap.Create;
  NewBMP.Width := Src.Width;
  NewBMP.Height := Src.Height;
  NewBMP.PixelFormat := pf8Bit;
  NewBMP.Canvas.Draw(0,0,Src);
  Src := NewBMP;
end else NewBMP := nil;
Result := TMemoryStream.Create;
Header := InputStream('texheader');
Result.Size := Src.Width*Src.Height+256*4+Header.Size;
Result.Position := 0;
Result.CopyFrom(Header,0);
Result.Position := 0;

PB1 := Result.Memory;
Inc(PB1,Header.Size);
GetPaletteEntries(Src.Palette,0,256,PB1^);
PPal := Pointer(PB1);
For I := 0 to 256 do begin
  B := PPal^.peRed;
  PPal^.peRed := PPal^.peBlue;
  PPal^.peBlue := B;
  PPal^.peFlags := $FF;
  Inc(PPal);
end;
For I := 0 to Src.Height-1 do begin
  PB1 := Src.ScanLine[I];
  PB2 := Result.Memory;
  Inc(PB2,Src.Width*I+256*4+Header.Size);
  CopyMemory(PB2,PB1,Src.Width);
end;

Result.Position := $3C;
I := Src.Width;
Result.WriteBuffer(I,4);
I := Src.Height;
Result.WriteBuffer(I,4);

Result.Position := $58;
I := 256;
Result.WriteBuffer(I,4);

Result.Position := 0;
Header.Free;
If NewBMP<>nil then NewBMP.Free;
end;

end.
