unit kapdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Cappo, CommDlg, ZipDir,
  Ole2,
  ShlObj;

Const
     MAX_ZIP_FILES = 4096;

type
  TFolderDialog = class(TComponent)
  private
         FTitle,FPath,FSimple: String;
         procedure ReadOnly(Val:String);
  public
        Function Execute:Boolean;
  published
           property Title: String read FTitle write FTitle;
           property SimpleName: String read FSimple write ReadOnly;
           property Path: String read FPath write ReadOnly;
//           property Root: String read FRoot write FRoot;
  end;
{$IFNDEF VER100}
  TCappoOpen = class(TOpenDialog)
  protected
    { Protected declarations }
    Zip:      TZipDir;
    Altered : Boolean;
    FZipFiles: TStringList;
    FZipFilter: String;
    FZipMulti:  Boolean;
    FAnim:      Boolean;
    Lst:      HWND;
    Chk:      HWND;
    Dlg:      HWND;
    WinPos:   TRect;
    Fnt:      TFont;
    SelFile:  String;

    function Message(var Msg:TMessage):Boolean;Override;Export;
{    procedure DefaultHandler(var Message); virtual;
    procedure Dispatch(var Message); virtual;
 } public
    { Public declarations }
    function Execute:Boolean;Override;
    constructor Create(Owner:TComponent); Override;
    destructor Destroy; Override;
  published
    { Published declarations }
    property ZipFiles: TStringList read FZipFiles write FZipFiles;
    property ZipFilter: String read FZipFilter write FZipFilter;
    property ZipMultiSelect: Boolean read FZipMulti write FZipMulti;
    property Animate: Boolean read FAnim write FAnim;
  end;
{$ENDIF}
procedure Register;

{$IFNDEF VER100}
function EnumChild(H:HWND;LP:LPARAM):Boolean;far;Stdcall;
{$ENDIF}

implementation

procedure Register;
begin
  RegisterComponents('Cappo', [{$IFNDEF VER100}TCappoOpen,{$ENDIF}TFolderDialog]);
end;

procedure TFolderDialog.ReadOnly(Val:String);
begin end;

function TFolderDialog.Execute:Boolean;
var
BI:       TBROWSEINFO;
NT,NT2:   array[0..MAX_PATH] of char;
P:        PItemIDList;
begin
BI.hWndOwner := (Owner as TWinControl).Handle;
BI.pIdlRoot := nil;
BI.pszDisplayName := @NT;
BI.lpszTitle := @NT2;
StrPCopy(NT2,Title);
BI.ulFlags := 0;
BI.lpFn := nil;
P := SHBrowseForFolder(BI);
If P <> nil then begin
   Result := True;
   FSimple := StrPas(NT);
   If SHGetPathFromIDList(P,@NT) then begin
      FPath := StrPas(NT);
      If FPath[Length(FPath)] <> '\' then
         FPath := FPath + '\';
   end;
   CoTaskMemFree(P);
end else Result := False;
end;
{$IFNDEF VER100}
function TCappoOpen.Message(var Msg:TMessage):Boolean;
var
I,J,K,L: Integer;
R:       TRect;
NT:      array[0..255] of char;
Select:  array[1..MAX_ZIP_FILES] of Longint;
Styl:    DWORD;
Pth:     Boolean;
S:       String;
begin
Inherited Message(Msg);
If (Msg.Msg = WM_ENTERIDLE) and (Altered) and (FAnim) then begin
   GetWindowRect(Msg.lParam,R);
   If (R.Bottom-R.Top) < (WinPos.Bottom-WinPos.Top+120) then begin
      R.Bottom := R.Bottom + 1;
      SetWindowPos(Msg.lParam,HWND_TOP,0,0,R.Right-R.Left,R.Bottom-R.Top,SWP_NOMOVE or SWP_SHOWWINDOW);
   end;
end;
If (Msg.Msg = WM_ENTERIDLE) and (Not Altered) then begin
   GetWindowRect(Msg.lParam,WinPos);
   If Not FAnim then
      SetWindowPos(Msg.lParam,HWND_TOP,0,0,WinPos.Right-WinPos.Left,WinPos.Bottom-WinPos.Top+120,SWP_NOMOVE or SWP_SHOWWINDOW);
   Styl := WS_VSCROLL or WS_CHILD or WS_BORDER or LBS_MULTICOLUMN
   {or DS_3DLOOK} or DS_CONTROL or LBS_NOTIFY or LBS_HASSTRINGS
   or WS_HSCROLL;
   If FZipMulti then Styl := Styl or LBS_MULTIPLESEL {or LBS_EXTENDEDSEL};
   Lst := CreateWindow('LISTBOX','CAPPODLGLIST',Styl,10,WinPos.Bottom-WinPos.Top-20,
   WinPos.Right-WinPos.Left-25,100,Msg.lParam,0,hInstance,nil);
   SendMessage(Lst,WM_SETFONT,Fnt.Handle,Longint(True));
   SendMessage(Lst,LB_SETCOLUMNWIDTH,(WinPos.Right-WinPos.Left-25) div 2,0);
   ShowWindow(Lst,SW_SHOW);
   Chk := CreateWindow('BUTTON','CAPPODLGCHECK', WS_CHILD or BS_AUTOCHECKBOX or DS_CONTROL,
       10,WinPos.Bottom-WinPos.Top+75,160{R.Right-R.Left-25},20,Msg.lParam,0,hInstance,nil);
   StrPCopy(NT,'Show paths inside ZIP files');
   SendMessage(Chk,WM_SETFONT,Fnt.Handle,Longint(True));
   SendMessage(Chk,WM_SETTEXT,0,Longint(@NT));
   ShowWindow(Chk,SW_SHOW);

   Altered := True; DLG := Msg.lParam;
//   EnumChildWindows(Msg.lParam,@EnumChild,Lst);
end;
If (Altered) and (Msg.Msg = WM_ENTERIDLE) then begin
   If FZipMulti then begin
      I := SendMessage(Lst,LB_GETSELCOUNT,0,0);
      If (I <> LB_ERR) and (I > 0) then begin
         FZipFiles.Clear;
         I := SendMessage(Lst,LB_GETSELITEMS,MAX_ZIP_FILES,Longint(@Select));
         For J := 1 to I do begin
          K := SendMessage(Lst,LB_GETTEXT,Select[J],Longint(@NT));
          If K <> LB_ERR then begin
             S := SwapChar(Uppercase(StrPas(NT)),'\','/');
             For L := 0 to Zip.ZipContents.Count-1 do
                 If Uppercase(SwapChar(Copy(ZipDirEntry(Zip.ZipContents[L]^).Filename,Length(ZipDirEntry(Zip.ZipContents[L]^).Filename)-Length(S)+1,Length(S)),'\','/')) = S then
                    FZipFiles.Add(ZipDirEntry(Zip.ZipContents[L]^).Filename);
          end;
         end;
      end;
    end else begin
          I := SendMessage(Lst,LB_GETCURSEL,0,0);
          If I <> LB_ERR then begin
             I := SendMessage(Lst,LB_GETTEXT,I,Longint(@NT));
             If I <> LB_ERR then begin
                FZipFiles.Clear;
                S := SwapChar(Uppercase(StrPas(NT)),'\','/');
                For L := 0 to Zip.ZipContents.Count-1 do
                 If Uppercase(SwapChar(Copy(ZipDirEntry(Zip.ZipContents[L]^).Filename,Length(ZipDirEntry(Zip.ZipContents[L]^).Filename)-Length(S)+1,Length(S)),'\','/')) = S then
                    FZipFiles.Add(ZipDirEntry(Zip.ZipContents[L]^).Filename);
             end;
          end;
      end;

    I := SendMessage(DLG,CDM_GETFILEPATH,255,Longint(@NT));
    If I = 0 then Exit;
    If StrPas(NT) <> SelFile then SelFile := StrPas(NT)
       else Exit;
    While I > 0 do
          I := SendMessage(LST,LB_DELETESTRING,0,0);
    If Uppercase(ExtractFileExt(SelFile)) <> '.ZIP' then Exit;
    Zip.ZipFilename := SelFile;
    I := SendMessage(Chk,BM_GETCHECK,0,0);
    If I = BST_UNCHECKED then Pth := False else Pth := True;
    for I :=0 to Zip.Count-1 do
        with ZipDirEntry(Zip.ZipContents[I]^) do
             If Filename[Length(Filename)] <> '/' then begin
                S := SwapChar(Filename,'/','\');
                If Pth then StrPCopy(NT,S)
                   else StrPCopy(NT,ExtractFileName(S));
                If (FZipFilter = '') or (MatchWildcard(Uppercase(FZipFilter),Uppercase(ExtractFilename(S)))) then
                   SendMessage(LST,LB_ADDSTRING,0,Longint(@NT));
             end;

end;

end;

function TCappoOpen.Execute:Boolean;
var
Old:     TStringList;
begin
Old := TStringList.Create;
Altered := False;
Fnt := TFont.Create;
Fnt.Size := 7;
Old.AddStrings(FZipFiles);
FZipFiles.Clear;
Result := Inherited Execute;
DestroyWindow(Lst);
DestroyWindow(Chk);
Fnt.Free;
If Not Result then FZipFiles.AddStrings(Old);
Old.Free;
end;

function EnumChild(H:HWND;LP:LPARAM):Boolean;Stdcall;far;
var
NT:      array[0..255] of char;
begin
GetClassName(H,@NT,255);
SendMessage(LP,LB_ADDSTRING,0,Longint(@NT));
Result := True;
end;

constructor TCappoOpen.Create(Owner:TComponent);
begin
Inherited Create(Owner);
Zip := TZipDir.Create(nil);
FZipFiles := TStringList.Create;
end;

destructor TCappoOpen.Destroy;
begin
Zip.Free;
FZipFiles.Free;
Inherited Destroy;
end;
{$ENDIF}
end.
